
 #include <OneWire.h>
OneWire  ds(4);  // on pin 10
//================================================================================================================

struct sensor
{
  uint8_t address[8];
};


 struct sensor   s1,s2,s3,s4,s5,s6,s7,s8;
 uint16_t result,result1;
float temperature,temperature_f,humidity;
uint8_t flag=0;
//================================================================================================================

void write_array(uint8_t* arr,int num);

uint8_t command_1[11]               =  {0xCC,0x66,0x05,0x83,0x0B,0x03,0xA5,0x0F,0x75,0x02,0xAA};
uint8_t command_2[19]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x05,0x83,0x0B,0x03,0xA5,0x0F,0x75,0x02,0xAA};
uint8_t command_3[15]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x01,0x7A,0x9F,0x93,0xAA};
uint8_t command_4[15]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x01,0x6A,0x9E,0x5F,0xAA}; 
uint8_t command_5[16]               =  {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66,0x02,0x55,0x01,0xFE,0x26,0xAA};
uint8_t command_6[38]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C, 0x66, 0x18, 0x11, 0x00, 0x00,0x02, 0xE3, 0x02, 0x88, 0xFD,0x03,0xDD, 0x08,0x02, 0xE3, 0x01, 0x89, 0xD4, 0x06, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x03,0xC8, 0x30, 0xAA};
uint8_t command_7[17]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C, 0x66, 0x03, 0x22, 0x00, 0x2A, 0xD6, 0x69, 0xAA};
uint8_t command_8[18]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C, 0x66, 0x04, 0x33, 0x00, 0x2A, 0x00, 0x18, 0xDD, 0xAA};
uint8_t command_9[17]               = {0x55,0x56,0xBC,0xE8,0x00,0x00,0x00,0x00,0x2C,0x66, 0x03, 0x22, 0x0E, 0x0C, 0x5D, 0xBC, 0xAA};
//===============================================================================================================
int SensorCount =0,OneWireDevices=0;
 byte i;
  byte present = 0;
  byte data[12];
  byte addr[8];
  
void write_array(uint8_t* arr,int num,int sensor_no)
{
 ds.reset();
  for(int i = 0;i<num;i++)
  {
   ds.write(arr[i], 1);
  }
 delay(80);
}

void read_response(int num)
{
  uint8_t arr[42];
 for(int i = 0;i<num;i++)
  {
    arr[i] = ds.read();
   }
  if(flag==1)
  {
    result = (  arr[3]<< 8);
    result |=arr[4] ;
     result1 = (  arr[6]<< 8);
    result1 |=arr[7] ;
    
    temperature= (float)(-45 + 175 / 65535.0 * (float)result);
    temperature_f= (float)(-49 + 315 / 65535.0 * (float)result);
    humidity= (float)(-6 + 125 / 65535.0 * (float)result1);

  }
  delay(200);
}
//=========================================================================================
bool  sensors_Init(void)
{
  ds.reset_search();
  uint8_t TryToFind=5;
  do
  {
    SensorCount = 0;  
    OneWireDevices = ds.search(addr);
    while (OneWireDevices)
    {
      delay(100);
      SensorCount++;
    switch (SensorCount)
    {
      case 1 :
              for ( i = 0; i < 8; i++) 
              {
                s1.address[i] = addr[i];
              }
              break;
     case 2 :
              for ( i = 0; i < 8; i++) 
              {
                s2.address[i] = addr[i];
              }
              break;
     case 3 :
              for ( i = 0; i < 8; i++) 
              {
                s3.address[i] = addr[i];
              }
              break;
     case 4 :
              for ( i = 0; i < 8; i++) 
              {
                s4.address[i] = addr[i];
              }
              break;
     case 5 :
              for ( i = 0; i < 8; i++) 
              {
                s5.address[i] = addr[i];
              }
              break;
     case 6 :
              for ( i = 0; i < 8; i++) 
              {
                s6.address[i] = addr[i];
              }
              break;
     case 7 :
              for ( i = 0; i < 8; i++) 
              {
                s7.address[i] = addr[i];
              }
              break;
    case 8 :
              for ( i = 0; i < 8; i++) 
              {
                s8.address[i] = addr[i];
              }
              break;
    default:
              break;
    }  
      OneWireDevices = ds.search(addr);
    }
    Serial.println(" ");
    if(SensorCount>0)
      break;
    TryToFind--;
  }while(TryToFind>0);
  if(TryToFind==0)
    return false;
  return true;
}


//=========================================================================================
void AMR(int s_num)
{
  switch (s_num)
    {
      case 1 :
              for ( i = 0; i < 8; i++) 
              {
                command_2[i+1]   = s1.address[i];
                command_3[i+1] = s1.address[i];
                command_4[i+1] = s1.address[i];
                command_5[i+1] = s1.address[i];
                command_6[i+1] = s1.address[i];
                command_7[i+1] = s1.address[i];
                command_8[i+1] = s1.address[i];
                command_9[i+1] = s1.address[i];
               }
              break;
     case 2 :
              for ( i = 0; i < 8; i++) 
              {
                command_2[i+1]   = s2.address[i];
                command_3[i+1] = s2.address[i];
                command_4[i+1] = s2.address[i];
                command_5[i+1] = s2.address[i];
                command_6[i+1] = s2.address[i];
                command_7[i+1] = s2.address[i];
                command_8[i+1] = s2.address[i];
                command_9[i+1] = s2.address[i];
              }
              break;
     case 3 :
              for ( i = 0; i < 8; i++) 
              {
                command_2[i+1]   = s3.address[i];
                command_3[i+1] = s3.address[i];
                command_4[i+1] = s3.address[i];
                command_5[i+1] = s3.address[i];
                command_6[i+1] = s3.address[i];
                command_7[i+1] = s3.address[i];
                command_8[i+1] = s3.address[i];
                command_9[i+1] = s3.address[i];
             }
              break;
     case 4 :
              for ( i = 0; i < 8; i++) 
              {
                command_2[i+1]   = s4.address[i];
                command_3[i+1] = s4.address[i];
                command_4[i+1] = s4.address[i];
                command_5[i+1] = s4.address[i];
                command_6[i+1] = s4.address[i];
                command_7[i+1] = s4.address[i];
                command_8[i+1] = s4.address[i];
                command_9[i+1] = s4.address[i];
              }
              break;
     case 5 :
              for ( i = 0; i < 8; i++) 
              {
                command_2[i+1]   = s5.address[i];
                command_3[i+1] = s5.address[i];
                command_4[i+1] = s5.address[i];
                command_5[i+1] = s5.address[i];
                command_6[i+1] = s5.address[i];
                command_7[i+1] = s5.address[i];
                command_8[i+1] = s5.address[i];
                command_9[i+1] = s5.address[i];
              }
              break;
     case 6 :
              for ( i = 0; i < 8; i++) 
              {
               command_2[i+1]   = s6.address[i];
                command_3[i+1] = s6.address[i];
                command_4[i+1] = s6.address[i];
                command_5[i+1] = s6.address[i];
                command_6[i+1] = s6.address[i];
                command_7[i+1] = s6.address[i];
                command_8[i+1] = s6.address[i];
                command_9[i+1] = s6.address[i];
              }
              break;
     case 7 :
              for ( i = 0; i < 8; i++) 
              {
                command_2[i+1]   = s7.address[i];
                command_3[i+1] = s7.address[i];
                command_4[i+1] = s7.address[i];
                command_5[i+1] = s7.address[i];
                command_6[i+1] = s7.address[i];
                command_7[i+1] = s7.address[i];
                command_8[i+1] = s7.address[i];
                command_9[i+1] = s7.address[i];
              }
              break;
    case 8 :
              for ( i = 0; i < 8; i++) 
              {
                command_2[i+1]   = s8.address[i];
                command_3[i+1] = s8.address[i];
                command_4[i+1] = s8.address[i];
                command_5[i+1] = s8.address[i];
                command_6[i+1] = s8.address[i];
                command_7[i+1] = s8.address[i];
                command_8[i+1] = s8.address[i];
                command_9[i+1] = s8.address[i];
              }
              break;
    default:
              break;
    }

}
//=========================================================================================
void init_th_sensor(int sensor_num)
{
  AMR(sensor_num);
  write_array(command_1,11,sensor_num);
  delay(900);     
  write_array(command_2,19,sensor_num);
  read_response(5);
  write_array(command_3,15,sensor_num);
  read_response(9);
  write_array(command_5,16,sensor_num);
  read_response(5);
  write_array(command_4,15,sensor_num);
  read_response(6);
    flag=0;
  write_array(command_6,38,sensor_num);
  read_response(5);
  write_array(command_7,17,sensor_num);
  read_response(24); 
}
//==========================================================================================
float get_temperature_deg(int sensor_num)
{
  AMR(sensor_num);
  write_array(command_8,18,sensor_num);
  flag =0;
  read_response(7);  
  write_array(command_9,17,sensor_num);
  flag=1;
  read_response(10);
  return temperature;
}
float get_temperature_far(int sensor_num)
{
  AMR(sensor_num);
  write_array(command_8,18,sensor_num);
  flag =0;
  read_response(7);  
  write_array(command_9,17,sensor_num);
  flag=1;
  read_response(10);
  return temperature_f;
}
float get_humidity(int sensor_num )
{
  AMR(sensor_num);
  write_array(command_8,18,sensor_num);
  flag =0;
  read_response(7);  
  write_array(command_9,17,sensor_num);
  flag=1;
  read_response(10);
  return humidity;
}
